USE Bank
-- Effekter av samtidighet ******************
-- Conn 2
BEGIN TRAN
	-- 2. Oppdaterer og forrsaker dirty read, non-repeatable read
	UPDATE Konto SET Saldo = 99999 WHERE KontoId = 3
	-- 4. Setter inn data og fr Phantom
	INSERT INTO Konto VALUES (4, 'Nissen', 100)
-- 6. Rollback
ROLLBACK TRAN

-- Isolasjonsniver ******************
-- Conn 2

--** Read Commited
BEGIN TRAN
	-- 2. Oppdaterer - Ingen Dirty read, men non-repeatable read
	UPDATE Konto SET Saldo = 99999 WHERE KontoId = 3
	-- 4. Commiter - den andre fr n lese
COMMIT TRAN
-- 5. Setter inn Phantom
INSERT INTO Konto VALUES (4, 'Nissen', 100)

--** Repeatable Read
-- 2. Ingen non-repeatable read
UPDATE Konto SET Saldo = 99999 WHERE KontoId = 3 -- blokkerer siden den andre vil ha rep.read
-- 5. Setter inn Phantom
INSERT INTO Konto VALUES (4, 'Nissen', 100)

--** Serializable
-- 2. Phantom try, blokkerer til den andre committer
INSERT INTO Konto VALUES (4, 'Nissen', 100)

-- Store og sm kunder i banken ******************
-- Gran gr fra liten til stor kunde
UPDATE Konto SET Saldo = 1000 WHERE KontoId = 2

-- Snapshot ******************
-- Gran gr fra liten til stor kunde
UPDATE Konto SET Saldo = 1000 WHERE KontoId = 2

-- Deadlocks ******************
-- Conn 2
-- 2. Alle fire linjer
BEGIN TRAN
	INSERT Bar VALUES (1)
	SELECT * FROM Foo
ROLLBACK TRAN