-- This script shows all locks for all transactions in the current database.
-- Useful for diagnosing blocking etc.

SELECT  L.request_session_id AS SPID, 
		ST.text AS MostRecentSql,
        DB_NAME(L.resource_database_id) AS [Database],
        O.Name AS LockedObject,
        --P.object_id AS LockedObjectId, 
        L.resource_type AS LockedResource, 
		L.resource_description AS [Description],
        L.request_mode AS LockType,
		L.request_status AS [Status]
FROM    sys.dm_tran_locks L
        JOIN sys.partitions P ON P.hobt_id = L.resource_associated_entity_id
        JOIN sys.objects O ON O.object_id = P.object_id
        JOIN sys.dm_exec_sessions ES ON ES.session_id = L.request_session_id
        JOIN sys.dm_tran_session_transactions TST ON ES.session_id = TST.session_id
        JOIN sys.dm_tran_active_transactions AT ON TST.transaction_id = AT.transaction_id
        JOIN sys.dm_exec_connections CN ON CN.session_id = ES.session_id
        CROSS APPLY sys.dm_exec_sql_text(CN.most_recent_sql_handle) AS ST
WHERE   resource_database_id = db_id()
ORDER BY L.request_session_id, L.resource_database_id, O.name, L.resource_description